// JGameEx28.java

import ch.aplu.jgamegrid.*;
import ch.aplu.util.*;
import java.awt.*;

public class JGameEx28 extends GameGrid implements GGActorCollisionListener
{
  public JGameEx28()
  {
    super(600, 600, 1, null, "sprites/town.jpg", false);
    setTitle("Move dart with mouse to pick the balloon");
    setSimulationPeriod(50);
    playSound(this, GGSound.DUMMY);
    getBg().clear(new Color(182, 220, 250));

    Dart dart = new Dart();
    addActor(dart, new Location(100, 300));
    addMouseListener(dart, GGMouse.lDrag);
    dart.setCollisionSpot(new Point(30, 0)); // Endpoint of dart needle
    
    for (int i = 0; i < 10; i++)
    {
      Actor balloon = new Actor("sprites/balloon.gif");
      addActor(balloon, new Location((int)(500*Math.random() + 50 ), (int)(500*Math.random() + 50)));
      dart.addCollisionActor(balloon);
      dart.addActorCollisionListener(this);
    }
    show();
    doRun();
  }

  public int collide(Actor actor1, Actor actor2)
  {
    actor2.removeSelf();
    playSound(this, GGSound.PING);  
    return 0;
  }

  public static void main(String[] args)
  {
    new JGameEx28();
  }
}

// --------------------- class Dart -----------------------
class Dart extends Actor implements GGMouseListener
{
  private Location oldLocation = new Location();

  public Dart()
  {
    super(true, "sprites/dart.gif");  // Rotatable
  }

  public boolean mouseEvent(GGMouse mouse)
  {
    Location location =
      gameGrid.toLocationInGrid(mouse.getX(), mouse.getY());
    setLocation(location);
    double dx = location.x - oldLocation.x;
    double dy = location.y - oldLocation.y;
    if (dx * dx + dy * dy < 25)
      return true;
    double phi = Math.atan2(dy, dx);
    setDirection(Math.toDegrees(phi));
    oldLocation.x = location.x;
    oldLocation.y = location.y;
    return true;
  }
}

